/*****************************************************************************
*
* Copyright (c) [2009] Novell, Inc.
* All Rights Reserved.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of version 2 of the GNU General Public License as
* published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.   See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, contact Novell, Inc.
*
* To contact Novell about this file by physical or electronic mail,
* you may find current contact information at www.novell.com
*
*-----------------------------------------------------------------------------
*
*                 $Author: Russ Young
*                 $Modified by: <Modifier>
*                 $Mod Date: <Date Modified>
*                 $Revision: 0.0
*-----------------------------------------------------------------------------
* This module is used to:
*        <Description of the functionality of the file >
*
*
*******************************************************************************/
#ifndef _CSPObjectIterator_H_
#define _CSPObjectIterator_H_

#include "CSPStore.h"

typedef enum
{
	CUR = 0,
	END,
	SET
} IndexOrigin;


class CSPObjectIterator
{
public:
	CSPObjectIterator(HFCURSOR cursor, int count, FLMBOOL includeColId);
	virtual ~CSPObjectIterator(void);
	int NextXml(CSPStore *pStore, FLMUNICODE *pOriginalBuffer, int nChars);
	bool SetIndex(IndexOrigin origin, int offset);

	
private:
	int			m_Count;
	int			m_Index;
	FLMUINT		*m_pRecords;
	FLMBOOL		m_includeColId;
};

#endif // _CSPObjectIterator_H_

